//+------------------------------------------------------------------+
//|                                                        BB-II.mq4 |
//|                                        Copyright  2007, DocSoft |
//|                                           http://igdoca.tomsk.ru |
//|------------------------------------------------------------------|
//| Ver.08.    M05    25.08.09                                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, DocSoft"

#include <stdlib.mqh>

#define  STATE_WAIT_BUY    1
#define  STATE_WAIT_SELL   2
#define  STATE_BUY_CLOSE   4
#define  STATE_SELL_CLOSE  8


extern int    paramMAporog  = 4;//20;
extern int    paramMAperiod = 3;//15;
extern int    paramMAshift  = 1;
extern int    paramMAprice  = 5;
extern double vLots         = 1.0;
extern int    paramSlippage = 3;

double paramDivisor  = 0;//2.5;

datetime  LastTime = 0;
int gObject = 0;

///////////////////////////////////////////////////////////

#define  LONG         0
#define  DIR_UP       1
#define  DIR_DOWN     2
#define  MAYBE_PIVOT  4
#define  KILL_PIVOT   8

int  fState = 0;
double prevVals[3];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void init()
{
    LastTime = Time[0];
    prevVals[0] = 0;

}
//=========================================================

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit()
{
}
//=========================================================

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start()
{
    ///////////////////////////////////////////////////////
    //  New Bar Only
    if (LastTime == Time[0])
        return;

    LastTime = Time[0];

    int nMagic = GetMagic(Symbol());
    if (nMagic == 0) {
        Print("Unknown MAGIC for ", Symbol());
        return;
    }

    ///////////////////////////////////////////////////////
    //  TF      nMax
    //  M15     500
    //  M30     500
    //  H1      200

    int nMax = 500;
    int ret = GetSignal(nMax, paramMAshift, prevVals);

    if (ret == 0)
        return;

    ///////////////////////////////////////////////////////


    ///////////////////////////////////////////////////////
    //  Main cycle

    if ((fState == 0 || fState == STATE_WAIT_SELL) && ret == 1) {
        CloseAllOrders(OP_BUY);
        OpenPosition(Symbol(), OP_SELL, vLots, paramSlippage);
        fState = STATE_WAIT_BUY;
    }

    if ((fState == 0 || fState == STATE_WAIT_BUY) && ret == -1) {
        CloseAllOrders(OP_SELL);
        OpenPosition(Symbol(), OP_BUY, vLots, paramSlippage);
        fState = STATE_WAIT_SELL;
    }
}
//=========================================================

int GetSignal (int nMax, int shift, double& prevVals[])
//  prevVals[3] - [0]     SMA.
//                [1] .  
//                [2] . .  
{
    int j, k, pos;
    double currMA, sum;

    ///////////////////////////////////////////////////////
    //  Restore 
    if (prevVals[0] < 0.1) {

        pos = nMax;
        sum = 0;
        for(k = 0; k < paramMAperiod; k++, pos--) {
            sum += vPrice(paramMAprice, pos);
        }
        prevVals[0] = sum/paramMAperiod;

        for ( ; shift < pos; pos--) {
            currMA = (vPrice(paramMAprice, pos) + (paramMAperiod-1)*prevVals[0])/paramMAperiod;
            prevVals[0] = currMA;

            j = 0.5+MathAbs(prevVals[1]-currMA)/Point;
            if (j >= paramMAporog) {
                prevVals[2] = prevVals[1];
                prevVals[1] = currMA;
            }
        }
    }
    ///////////////////////////////////////////////////////

    pos = shift;
    currMA = (vPrice(paramMAprice, pos) + (paramMAperiod-1)*prevVals[0])/paramMAperiod;
    prevVals[0] = currMA;

    ///////////////////////////////////////////////////////
    pos = 0;
    j = 0.5+MathAbs(prevVals[1]-currMA)/Point;
    if (j >= paramMAporog) {

        if (prevVals[2] > prevVals[1] && prevVals[1] < currMA)
            pos = -1;

        if (prevVals[2] < prevVals[1] && prevVals[1] > currMA)
            pos = 1;

        prevVals[2] = prevVals[1];
        prevVals[1] = currMA;
    }

if (IsOptimization() == false) {
    string szName = "ArrTest_";
    szName = szName+gObject;
    ObjectCreate(szName, OBJ_ARROW, 0, Time[shift], prevVals[1]);
    ObjectSet   (szName, OBJPROP_ARROWCODE, 159);
    ObjectSet   (szName, OBJPROP_COLOR,     Gold);
    gObject++;
}
    return(pos);
}
//=========================================================

double vPrice (int nPrice, int shift)
{
//  PRICE_CLOSE      0   
//  PRICE_OPEN       1   
//  PRICE_HIGH       2   
//  PRICE_LOW        3   
//  PRICE_MEDIAN     4  , (high+low)/2 
//  PRICE_TYPICAL    5  , (high+low+close)/3 
//  PRICE_WEIGHTED   6   , (high+low+close+close)/4 
//  PRICE_OPEN_CLOSE 7 (open+close)/2 

    switch (nPrice) {
    case PRICE_CLOSE :
        return(Close[shift]);
    case PRICE_OPEN :
        return(Open[shift]);
    case PRICE_HIGH :
        return(High[shift]);
    case PRICE_LOW :
        return(Low[shift]);
    case PRICE_MEDIAN :
        return(0.5*(High[shift]+Low[shift]));
    case PRICE_TYPICAL :
        return((High[shift]+Low[shift]+Close[shift])/3);
    case PRICE_WEIGHTED :
        return(0.25*(High[shift]+Low[shift]+2*Close[shift]));
    default : //PRICE_OPEN_CLOSE : // 7
        return(0.5*(Open[shift]+Close[shift]));
    }
}
//=========================================================


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 13.06.2007                                                     |
//|   :  .      .        |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""  NULL -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
int OpenPosition (string sy, int op, double ll, int Slippage=0, double sl=0, double tp=0, int mn=0)
{
    //color  clOpen;
    double pp;
    int    err, ticket;

    if (sy == "" || sy == "0") sy = Symbol();
    if (op == OP_BUY) {
        pp = NormalizeDouble(MarketInfo(sy, MODE_ASK), Digits);//clOpen=clOpenBuy;
    }
    else {
        pp = NormalizeDouble(MarketInfo(sy, MODE_BID), Digits);//clOpen=clOpenSell;
    }

    ticket = OrderSend(sy, op, ll, pp, Slippage, sl, tp, "", mn);//, clOpen);
    if (ticket < 0) {
        err = GetLastError();
        Print("Error(",err,") open ", GetNameOP(op), ": ",ErrorDescription(err));
        Print("Ask=",Ask," Bid=",Bid," sy=",sy," lot=",ll, " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
    }
    return(ticket);
}
//=========================================================

bool ClosePosBySelect (int nType, double divisor, int Slippage)
{
    bool   ret = true;
    double pp, step;
    int k, dg = MarketInfo(OrderSymbol(), MODE_DIGITS);
    string szSymbol = OrderSymbol();

    double lots = OrderLots();
    if (divisor > 1 && lots > 10*MarketInfo(szSymbol, MODE_MINLOT)) {
        lots /= divisor;
        step = MarketInfo(szSymbol, MODE_LOTSTEP);
        k = lots/step;
        lots = k*step;
    }

    if (nType == OP_BUY) {
        pp  = NormalizeDouble(MarketInfo(szSymbol, MODE_BID), dg);
        ret = OrderClose(OrderTicket(), lots, pp, Slippage);
    }
    if (nType == OP_SELL) {
        pp  = NormalizeDouble(MarketInfo(szSymbol, MODE_ASK), dg);
        ret = OrderClose(OrderTicket(), lots, pp, Slippage);
    }
    return(ret);
}
//=========================================================

int GetMagic (string szSymbol)
{
    string str = StringSubstr(szSymbol, 0, 6);

    if (str == "EURUSD")
        return(101);
    if (str == "GBPUSD")
        return(102);
    if (str == "USDJPY")
        return(103);
    if (str == "EURJPY")
        return(104);
    if (str == "GBPJPY")
        return(105);
    return(0);
}
//=========================================================

string GetNameOP(int op)
{
    switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
    }
}
//=========================================================

void CloseAllOrders (int op)
{
    int j, k, err;

    k = OrdersTotal();
    //Print(" => T=", TimeToStr(PivotTime), " P=", DoubleToStr(PivotVal,Digits), " k=", k);

    for (j = k-1; 0 <= j; j--) {

        if (OrderSelect(j, SELECT_BY_POS) == false) {
            err = GetLastError();
            Print("Error(", err, ") selecting order: ", ErrorDescription(err));
            Print("Ask=",Ask," Bid=",Bid," sy=",OrderSymbol());
            continue;
        }

        if (OrderSymbol() != Symbol())
            continue;

        if (false == ClosePosBySelect(op, paramDivisor, paramSlippage)) {
            err = GetLastError();
            Print("Error(", err, ") CLOSE ", GetNameOP(op), ErrorDescription(err));
            Print("Ask=",Ask," Bid=",Bid," sy=",OrderSymbol());
        }
    }
}
//=========================================================
